# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cob_map_accessibility_analysis/CheckPointAccessibilityRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class CheckPointAccessibilityRequest(genpy.Message):
  _md5sum = "b406244933de86ab08575478d23717b7"
  _type = "cob_map_accessibility_analysis/CheckPointAccessibilityRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Pose2D[] points_to_check
bool approach_path_accessibility_check

================================================================================
MSG: geometry_msgs/Pose2D
# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta"""
  __slots__ = ['points_to_check','approach_path_accessibility_check']
  _slot_types = ['geometry_msgs/Pose2D[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       points_to_check,approach_path_accessibility_check

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CheckPointAccessibilityRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.points_to_check is None:
        self.points_to_check = []
      if self.approach_path_accessibility_check is None:
        self.approach_path_accessibility_check = False
    else:
      self.points_to_check = []
      self.approach_path_accessibility_check = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.points_to_check)
      buff.write(_struct_I.pack(length))
      for val1 in self.points_to_check:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
      buff.write(_struct_B.pack(self.approach_path_accessibility_check))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.points_to_check is None:
        self.points_to_check = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points_to_check = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose2D()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
        self.points_to_check.append(val1)
      start = end
      end += 1
      (self.approach_path_accessibility_check,) = _struct_B.unpack(str[start:end])
      self.approach_path_accessibility_check = bool(self.approach_path_accessibility_check)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.points_to_check)
      buff.write(_struct_I.pack(length))
      for val1 in self.points_to_check:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
      buff.write(_struct_B.pack(self.approach_path_accessibility_check))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.points_to_check is None:
        self.points_to_check = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points_to_check = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose2D()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
        self.points_to_check.append(val1)
      start = end
      end += 1
      (self.approach_path_accessibility_check,) = _struct_B.unpack(str[start:end])
      self.approach_path_accessibility_check = bool(self.approach_path_accessibility_check)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
_struct_3d = struct.Struct("<3d")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cob_map_accessibility_analysis/CheckPointAccessibilityResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class CheckPointAccessibilityResponse(genpy.Message):
  _md5sum = "5f3c377d86bd78d373d82f6a042c05ca"
  _type = "cob_map_accessibility_analysis/CheckPointAccessibilityResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool[] accessibility_flags
"""
  __slots__ = ['accessibility_flags']
  _slot_types = ['bool[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       accessibility_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CheckPointAccessibilityResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.accessibility_flags is None:
        self.accessibility_flags = []
    else:
      self.accessibility_flags = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.accessibility_flags)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(struct.pack(pattern, *self.accessibility_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.accessibility_flags = struct.unpack(pattern, str[start:end])
      self.accessibility_flags = map(bool, self.accessibility_flags)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.accessibility_flags)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(self.accessibility_flags.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.accessibility_flags = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
      self.accessibility_flags = map(bool, self.accessibility_flags)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
class CheckPointAccessibility(object):
  _type          = 'cob_map_accessibility_analysis/CheckPointAccessibility'
  _md5sum = 'c42c7449dffc73e50011cd7a1eb83e23'
  _request_class  = CheckPointAccessibilityRequest
  _response_class = CheckPointAccessibilityResponse
